#!/usr/bin/zsh
#
set -xe
zsh -n "$0"

abort () {
  echo "Error:" "$@" >&2
  exit 1
}

[[ "$1" == "-d" ]] && DEBUG=y

usrn=brnosummercamp
homd=/home/${usrn}
#[[ -n "$DEBUG" ]] && homd="$HOME"
[[ -d "$homd" ]]

cred="${homd}/Credentials.txt"

zshrc="${homd}/.zshrc"
[[ -r "$zshrc" ]]

curu="$(grep '^export KEY=' "$zshrc" | cut -d'"' -f2)"
keyf="./key"
[[ -r "$keyf" ]] && curs="$(cat "$keyf")" || curs=

[[ -z "$DEBUG" ]] && [[ "$curs" == "$curu" ]]


pcidf="./pcid"
[[ -r "$pcidf" ]]

pcid="$(cat "$pcidf")"
[[ -n "$pcid" ]]

keysf="./pc${pcid}.txt"
[[ -r "$keysf" ]]

[[ -n "$curs" ]] && {
  nkey="$(grep -A 1 -E "\s*${curs}:" "$keysf" | tail -n +2)"
  :
} || {
  nkey="$(head -n 1 "$keysf")"
}
[[ -n "$nkey" ]] && {

  nkey="$(echo "$nkey" | tr -s '\t' ' ' | tr -s ':' ' ' | sed -e 's/^\s*//g' | sed -e 's/\s*$//g')"

  cname="$(echo "$nkey" | cut -d' ' -f2)"
  nkey="$(echo "$nkey" | cut -d' ' -f1)"

  [[ -n "$nkey" && -n "$cname" ]]
  [[ $(wc -c <<< "$nkey") -eq 17 ]]

  echo "$curu -> $nkey"


  [[ -n "$DEBUG" ]] && exit 2

  sou="${homd}/sources"

  echo "${nkey}" > "${keyf}"

  mkdir -p "${homd}/"
  echo -e " Web: http://bughunting.cz/\n Codename: ${cname}\n KEY: ${nkey}\nonce" > "${cred}"

  [[ -z "$curu" ]] && {
    echo '[[ -z "$SOURCES" ]] && {' >> "$zshrc"

    echo "export SOURCES=\"${sou}\"" >> "$zshrc"
  #  echo "export NOGIT=\"1\"" >> "$zshrc"
    echo "export KEY=\"${nkey}\"" >> "$zshrc"

 #   echo '/usr/share/bughunting/scripts/entry-copy-tasks.sh echo -n &>/dev/null' >> "$zshrc"

    echo "grep ^once$ '${cred}' && { sed -i '/^once$/d' '${cred}' ; xdg-open '${cred}'; }" >> "$zshrc"
    echo '}' >> "$zshrc"
    echo "cd \"${sou}\"" >> "$zshrc"

    :
  }
#  } || {
#    tst="$(sed -e "/KEY/ s/${curu}/${nkey}/" "${zshrc}")"
#
#    grep '^export KEY=' <<< "$tst" | grep -qE "${nkey}"
#
#    sed -i -e "/KEY/ s/${curu}/${nkey}/" "${zshrc}"
}

####################################

set +e

usrn=brnosummercamp
homd=/home/${usrn}

cred="${homd}/Credentials.txt"

codename="$(grep Codename "$cred" | cut -d' ' -f3)"
rep="repositories/${codename}"
tasks_dir="${TASKS:-/var/lib/bughunting/tasks}"
sources="${homd}"/sources/

rm -rf "${sources}"

[[ -d "${rep}/" ]] && {
  rm -rf "${tasks_dir}"/.git/
  cp -vr "${rep}"/.git "${tasks_dir}"/

  mkdir -p "${sources}"
  cp -vr "${rep}"/.git "${sources}"
  :
} || {
  sudo -u "${usrn}" bash -c "export SOURCES=$sources; export KEY=$nkey; /usr/share/bughunting/scripts/entry-copy-tasks.sh echo -n"
}

chown -R "${usrn}:" "${homd}/sources/"

priv="repositories/${codename}.private"

[[ -r "${priv}" ]] && {
      mkdir -p /root/.ssh/
      cp "${priv}" /root/.ssh/id_ed25519
      echo 'gitlab.com ssh-ed25519 AAAAC3NzaC1lZDI1NTE5AAAAIAfuCHKVTjquxvt6CM6tdG4SLp1Btn/nOeHHE5UOzRdf' >> /root/.ssh/known_hosts
      chmod 0600 /root/.ssh/*

      mkdir -p ${homd}/.ssh/
      cp "${priv}" ${homd}/.ssh/id_ed25519
      echo 'gitlab.com ssh-ed25519 AAAAC3NzaC1lZDI1NTE5AAAAIAfuCHKVTjquxvt6CM6tdG4SLp1Btn/nOeHHE5UOzRdf' >> ${homd}/.ssh/known_hosts
      chmod 0600 ${homd}/.ssh/*
      chown -R ${usrn}: "${homd}/.ssh/"
}

# Some root cleanup

mkdir /tmp/root

cp -r pcid run.sh key /tmp/root/

rm -rf /root/*
rm -rf /root/.bash_history

cp -r /tmp/root/* /root/

rm -rf /tmp/root
