#!/usr/bin/bash

set -e
bash -n "$0"

USE="bughunting"
SER='quay.io'

[[ "$1" == "-i" ]] && {
  USE=pvalena
  SER="docker-registry.upshift.redhat.com"
  shift
  :
}

[[ "$1" == "-l" ]] && {
  TOK="$2"
  shift 2
  :
}

[[ "$1" == "-p" ]] && {
  NAME="$2"
  shift 2
  :
} || NAME="${NAME:-bughunting}"

[[ "$1" == "-s" ]] && {
  SER="$2"
  shift 2
  :
}

[[ -n "$TOK" ]] && {
  set -x
  podman login -u "$USE" -p "$TOK" "$SER"
  { set +x; } &>/dev/null
}

[[ -z "$1" ]] && exec "$0" -s "$SER" server client
[[ "$1" == '--all' ]] && {
  shift
  exec "$0" -s "$SER" "$@" server devel client sshd #summer
}

echo "${@}" | tr -s ' ' '\n' \
  | xargs -i bash -c "
      set -x
      grep ':' <<< '{}' \
        && im='${NAME}/{}' \
        || im='${NAME}/{}:latest'

      podman tag \"\${im}\" \"${SER}/\${im}\" \
        && {
          im=\"${SER}/\${im}\"
          podman push \"\${im}\" \
            || podman push \"\${im}\" \

        } || exit 255
  "
