#!/usr/bin/bash

set -e
bash -n "$0"

die () {
  echo "Error:" "$@" >&2
  exit 1
}

get_creds () {
  cat "$1" \
    | grep -A 100000 '^players:' \
    | tail -n +2 | grep -v ^$ \
    | tr -s ':' ' ' \
    | cut -d' ' -f2- \
    | grep -v ' test$'
  :
}

bs="$(readlink -e "$(dirname "$0")/container_push.sh")"
[[ -x "$bs" ]] || die "bs missing: ${bs}"

creds="$(get_creds config/web.yml)"
[[ -n "$creds" ]] || echo "Credentails missing"

r="-r"

while read key codename; do
  set -x
  $bs "$@" $codename || break
  { set +x; } &>/dev/null
  r=
done <<< "$creds"
