#!/usr/bin/bash
#
set -xe
bash -n "$0"

abort () {
  echo "Error:" "$@" >&2
  exit 1
}

myd="$(dirname "$0")"
myd="$(readlink -e "$myd")"

[[ -n "$myd" ]]

rpms=rpms
[[ -d "$rpms" ]] || rpms='.'

RUN="set -xe; \
    \
    dnf install -y 'dnf-command(copr)'; \
    dnf copr enable -y pvalena/bughunting; \
    \
    for a in {,re}install update; do \
      dnf --nogpgcheck --nodocs \$a -y \
        ${rpms}/*/bughunting-20*.fc*.noarch.rpm \
        ${rpms}/*/bughunting-client*.fc*.noarch.rpm \
        ${rpms}/*/bughunting-tasks-*.rpm ||: ; \
    done; \
    \
    dnf remove -y bughunting-server bughunting-tasks-check bughunting-tasks-patch 'dnf-command(builddep)' rpm-build python3-GitPython perl-YAML-Syck perl-Data-Dumper; \
    \
    rpm -V bughunting-tasks; \
    \
    dnf --nogpgcheck --nodocs install -y 'dnf-command(copr)' ruby rubygems rvm irb git gitk python3-GitPython man; \
    \
    sed -i 's/^\(\s*host:\).*$/\1 bughunting.cz/' /etc/bughunting/client.yml; \
    \
    echo 'export EDITOR=nano' >> /root/.zshrc; \
    echo 'export EDITOR=nano' >> ~/.zshrc; \
    \
    cd; \
    set +e; \
    #rm -rf /home/student/sources; \
    rm -rf /etc/bughunting/remote_id_rsa*; \
    rm -rf /var/lib/bughunting/tasks/*/*.patch; \
    rm -rf /var/lib/bughunting/tasks/*/check/; \
    rm -rf /etc/bughunting/server.yml; \
    rm -rf /etc/bughunting/web.yml; \
    rm -rf /usr/share/bughunting/web/; \
    find /etc/bughunting -type f -iname '*.rpmnew' -delete -o -iname '*.rpmsave' -delete; \
    \
  " ||:

zsh -n "$RUN"
zsh -c "$RUN"
