#!/usr/bin/bash
#
set -xe
bash -n "$0"

# VARS
tasks_dir="${TASKS:-/var/lib/bughunting/tasks}"
allowlist="name|check_files|copy_task_on_server"

abort () {
  echo "Error:" "$@" >&2
  exit 1
}

ls -d ${tasks_dir}/*/ &>/dev/null || {
   echo "Invalid tasks dir: $tasks_dir" >&2
   exit 1
}

cd "$tasks_dir"

# Copy the installed tasks into the client's home
for task_path in $(ls -d */); do
  cat "${task_path}task.yml" \
    | sed -e ':a;N;$!ba;s/\n\(\S*\:[^\n]*\)\n\(\s*-\)/\n\1__nl__\2/' \
    | sed -e ':a;N;$!ba;s/\n\(\S*\:[^\n]*\)\n\(\s*-\)/\n\1__nl__\2/' \
    | sed -e ':a;N;$!ba;s/\n\(\S*\:[^\n]*\)\n\(\s*-\)/\n\1__nl__\2/' \
    | sed -e ':a;N;$!ba;s/\n\(\S*\:[^\n]*\)\n\(\s*-\)/\n\1__nl__\2/' \
    | sed -e ':a;N;$!ba;s/\n\(\S*\:[^\n]*\)\n\(\s*-\)/\n\1__nl__\2/' \
    | sed -e ':a;N;$!ba;s/\n\(\S*\:[^\n]*\)\n\(\s*-\)/\n\1__nl__\2/' \
    | sed -e ':a;N;$!ba;s/\n\(\S*\:[^\n]*\)\n\(\s*-\)/\n\1__nl__\2/' \
    | sed -e ':a;N;$!ba;s/\n\(\S*\:[^\n]*\)\n\(\s*-\)/\n\1__nl__\2/' \
    | sed -e ':a;N;$!ba;s/\n\(\S*\:[^\n]*\)\n\(\s*-\)/\n\1__nl__\2/' \
    | sed -e ':a;N;$!ba;s/\n\(\S*\:[^\n]*\)\n\(\s*-\)/\n\1__nl__\2/' \
    | grep -E "^($allowlist):" \
    | sed -e ':a;N;$!ba;s/\n\(\S*\:[^\n]*\)__nl__\(\s*-\)/\n\1\n\2/' \
    | sed -e ':a;N;$!ba;s/\n\(\S*\:[^\n]*\)__nl__\(\s*-\)/\n\1\n\2/' \
    | sed -e ':a;N;$!ba;s/\n\(\S*\:[^\n]*\)__nl__\(\s*-\)/\n\1\n\2/' \
    | sed -e ':a;N;$!ba;s/\n\(\S*\:[^\n]*\)__nl__\(\s*-\)/\n\1\n\2/' \
    | sed -e ':a;N;$!ba;s/\n\(\S*\:[^\n]*\)__nl__\(\s*-\)/\n\1\n\2/' \
    | sed -e ':a;N;$!ba;s/\n\(\S*\:[^\n]*\)__nl__\(\s*-\)/\n\1\n\2/' \
    | sed -e ':a;N;$!ba;s/\n\(\S*\:[^\n]*\)__nl__\(\s*-\)/\n\1\n\2/' \
    | sed -e ':a;N;$!ba;s/\n\(\S*\:[^\n]*\)__nl__\(\s*-\)/\n\1\n\2/' \
    | sed -e ':a;N;$!ba;s/\n\(\S*\:[^\n]*\)__nl__\(\s*-\)/\n\1\n\2/' \
    | sed -e ':a;N;$!ba;s/\n\(\S*\:[^\n]*\)__nl__\(\s*-\)/\n\1\n\2/' \
    > "${task_path}task_new.yml"

  mv -f "${task_path}task_new.yml" "${task_path}task.yml"
done
